ShamanWarning = LibStub("AceAddon-3.0"):NewAddon("Shaman Warning", "AceEvent-3.0", "AceConsole-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("ShamanWarning", true)

local function getOption(info)
	return (info.arg and ShamanWarning.db.profile[info.arg] or ShamanWarning.db.profile[info[#info]])
end;

local function setOption(info, value)
	local key = info.arg or info[#info]
	ShamanWarning.db.profile[key] = value
	--ShamanWarning:UpdateFrame() --
end;

local trinket_active = { false, false };

local options = {
	name = "ShamanWarning",
	type = "group",
	childGroups = "tab",
	args = {
		check = {
			name = "Check",
			hidden = true,
			type = "execute",
			func = "CheckTrinket",
		},
		elemental = {
			name = "Element",
			desc = L["Elemental"],
			type = "group",
			order = 1,
			args = {
				elemental = {
					name = L["Elemental Devastation"],
					desc = L["Toggles on/off Elemental Devastation proc warning"],
					order = 3,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				oath = {
					name = L["Elemental Oath"],
					desc = L["Toggles on/off Elemental Oath proc warning"],
					order = 4,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				clearcast = {
					name = L["Clearcasting"],
					desc = L["Toggles on/off Clearcasting proc warning"],
					order = 2,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
--				charged = {
--					name = "Charged",
--					desc = "Toggles on/off charged proc warning",
--					order = 1,
--					type = "toggle",
--					get = getOption,
--					set = setOption,
--				},
			},
		},
		enhancement = {
			name = "Enhance",
			desc = L["Enhancement"],
			type = "group",
			order = 2,
			args = {
				flurry = {
					name = L["Flurry"],
					desc = L["Toggles on/off Flurry proc warning"],
					order = 1,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
--				invigorated = {
--					name = "Invigorated",
--					desc  = "Toggles on/off Invigorated proc warning",
--					order = 2,
--					type = "toggle",
--					get = getOption,
--					set = setOption,
--				},
			},
		},
		restoration = {
			name = "Resto",
			desc = L["Restoration"],
			type = "group",
			order = 3,
			args = {
--				wavetrance = {
--					name = "Wave Trance",
--					desc = "Toggles on/off Wave Trance proc warning",
--					order = 4,
--					type = "toggle",
--					get = getOption,
--					set = setOption,
--				},
				earthshield = {
					name = L["Earth Shield"],
					desc = L["Toggles on/off Earth Shield removed warning"],
					order = 2,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				manatide = {
					name = L["Mana Tide Totem"],
					desc = L["Toggles on/off Mana Tide Totem warning"],
					order = 3,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				ancestral = {
					name = L["Ancestral Awakening"],
					desc = L["Toggles on/off Ancestral Awakening warning"],
					order = 1,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
			},
		},
--		trinket = {
--			name = "Trinkets",
--			desc = L["Trinket procs"],
--			type = "group",
--			order = 4,
--			args = {
--				trinket_1 = {
--					name = L["Trinket"].." #1",
--					type = "group",
--					guiInline = true,
--					order = 1,
--					args = {
--						trinket_1_name = {
--							name = trinket_1_name,
--							order = 1,
--							type = "description",
--						},
--						trinket_1_active = {
--							name = "Enabled",
--							desc = L["Toggles on/off trinket spell warning"],
--							order = 2,
--							hidden = trinket_active[1],
--							type = "toggle",
--							get = getOption,
--							set = setOption,
--						},
--					},
--				},
--				trinket_2 = {
--					name = L["Trinket"].." #2",
--					type = "group",
--					guiInline = true,
--					order = 1,
--					args = {
--						trinket_2_name = {
--							name = trinket_2_name,
--							order = 1,
--							type = "description",
--						},
--						trinket_2_active = {
--							name = "Enabled",
--							desc = L["Toggles on/off trinket spell warning"],
--							order = 2,
--							hidden = trinket_active[2],
--							type = "toggle",
--							get = getOption,
--							set = setOption,
--						},
--					},
--				},
--			},
--		},
		misc = {
			name = "Misc",
			desc = L["Misc spells"],
			type = "group",
			order = 5,
			args = {
				windfury = {
					name = L["Windfury"],
					desc = L["Toggles on/off Windfury proc warning"],
					order = 5,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				water = {
					name = L["Water Shield"],
					desc = L["Toggles on/off Water Shield removed warning"],
					order = 4,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				lightning = {
					name = L["Lightning Shield"],
					desc = L["Toggles on/off Lightning Shield removed warning"],
					order = 2,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				executioner = {
					name = L["Executioner"],
					desc = L["Toggles on/off Executioner proc warning"],
					order = 1,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				mongoose = {
					name = L["Mongoose"],
					desc = L["Toggles on/off Mongoose proc warning"],
					order = 3,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
			},
		},
	},
};

local defaults = {
	profile = {
		elemental = true,
		windfury = true,
		flurry = true,
		oath = true,
		water = true,
		clearcast = true,
		executioner = true,
		mongoose = true,
		invigorated = true,
		charged = true,
		wavetrance = true,
		earthshield = true,
		lightning = true,
		manatide = true,
		ancestral = true,
		trinket_1_active = false,
		trinket_2_active = false,
		trinket_1_name = "",
		trinket_2_name = ""
	},
};

--local trinket_list = {
--	[L["Dying Curse"]] = L["Dying Curse"],
--	[L["Sundial of the Exiled"]] = L["Now is the time!"],
--	[L["Hourglass of the Unraveller"]] = L["Rage of the Unraveller"],
--	[L["Scarab of the Infinite Cycle"]] = L["Spell Haste"],
--	[L["Shiffar's Nexus-Horn"]] = L["Call of the Nexus"],
--	[L["Sonic Booster"]] = L["Sonic Awareness"],
--	[L["Forge Ember"]] = L["Forge Ember"],
--	[L["Meteorite Whetstone"]] = L["Meteorite Whetstone"],
--	[L["Shard of Contempt"]] = L["Disdain"],
--	[L["Dragonspine Trophy"]] = L["Dragonspine Flurry"],
--	[L["Eye of Magtheridon"]] = L["Recurring Power"],
--	[L["Sextant of Unstable Currents"]] = L["Unstable Currents"],
--	[L["Tsunami Talisman"]] = L["Fury of the Crashing Waves"],
--	[L["Death Knight's Anguish"]] = L["Wracking Pains"],
--	[L["Serrah's Star"]] = L["Star of Light"],
--	[L["Madness of the Betrayer"]] = L["Forceful Strike"],
--	[L["Valonforth's Remembrance"]] = L["Purified Spirit"],
--	[L["Blackened Naaru Sliver"]] = L["Battle Trance"],
--	[L["Chuchu's Tiny Box of Horrors"]] = L["Tentacles"],
--	[L["Crusader's Locket"]] = L["Crusader's Glory"],
--	[L["Anvil of Titans"]] = L["Reflection of Torment"],
--	[L["Darkmoon Card: Greatness"]] = L["Darkmoon Card: Greatness"],
--	[L["Embrace of the Spider"]] = L["Embrace of the Spider"],
--	[L["Flow of Knowledge"]] = L["Now is the time!"],
--	[L["Mirror of Truth"]] = L["Reflection of Torment"],
--	[L["Tears of Bitter Anguish"]] = L["Tears of Anguish"],
--	[L["The Egg of Mortal Essence"]] = L["Essence of Life"],
--	[L["Grim Toll"]] = L["Grim Toll"]
--};

function ShamanWarning:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ShamanWarningDB", defaults, "Default");
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ShamanWarning", options);
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ShamanWarning", "ShamanWarning");
	self:RegisterChatCommand("ShamanWarning", "ChatCommand");
	self:RegisterChatCommand("sw", "ChatCommand");
	self:CheckTrinket();
end;

function ShamanWarning:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","CombatLogEvent");
	self:RegisterEvent("UNIT_INVENTORY_CHANGED","CheckTrinket");
end;

function ShamanWarning:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame);
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(ShamanWarning, "ShamanWarning", "ShamanWarning", input);
    end
end

function ShamanWarning:CombatLogEvent(a, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName)
	if event=="SPELL_AURA_APPLIED" and destFlags==0x511 then
		if spellName==L["Flurry"] and self.db.profile.flurry then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Flurry.mp3");
		end;
		if (spellName==L["Clearcasting"] or spellName=="Focused") and self.db.profile.clearcast then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Clearcast.mp3");
		end;
		if spellName==L["Elemental Devastation"] and self.db.profile.elemental then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Elemental.mp3");
		end;
		if spellName==L["Elemental Oath"] and self.db.profile.oath then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Storm.mp3");
		end;
		if spellName==L["Lightning Speed"] and self.db.profile.mongoose then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Lightning.mp3");
		end;
		if spellName==L["Executioner"] and self.db.profile.executioner then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Executioner.mp3");
		end;
--		if spellName=="Wave Trance" and self.db.profile.wavetrance then
--			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Power.mp3");
--		end;
--		if spellName=="Invigorated" and self.db.profile.invigorated then
--			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Power.mp3");
--		end;
--		if spellName=="Charged" and self.db.profile.charged then
--			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Power.mp3");
--		end;
	end;
	if event=="SPELL_AURA_REMOVED" and destFlags==0x511 then
		if spellName==L["Water Shield"] and self.db.profile.water then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Water.mp3");
		end;
		if spellName==L["Earth Shield"] and self.db.profile.earthshield then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Earth.mp3");
		end;
		if spellName==L["Lightning Shield"] and self.db.profile.lightning then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Light.mp3");
		end;
	end;
	if event=="SPELL_DAMAGE" and sourceFlags==0x511 then
		if spellName==L["Windfury Attack"] and self.db.profile.windfury then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\WindFury.mp3");
		end;
	end;
	if event=="SPELL_SUMMON" then
		if spellName==L["Mana Tide Totem"] and self.db.profile.manatide then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\ManaTide.mp3");
		end;
	end;
	if event=="SPELL_HEAL" and sourceFlags==0x511 then
		if spellName==L["Ancestral Awakening"] and self.db.profile.ancestral then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Power.mp3");
		end;
	end;
--	if event=="SPELL_ENERGIZE" or event=="SPELL_AURA_APPLIED" and sourceFlags==0x511 then
--		if self.db.profile.trinket_1_name~=nil and spellName==self.db.profile.trinket_1_name and self.db.profile.trinket_1_active then
--			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Bell.mp3");
--		end;
--		if self.db.profile.trinket_2_name~=nil and spellName==self.db.profile.trinket_2_name and self.db.profile.trinket_2_active then
--			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Bell.mp3");
--		end;
--	end;
end;

function ShamanWarning:GetTrinket()
	trinket_1_name = GetItemInfo(GetInventoryItemLink("player",13));
--	self:PTR("trinket_1",trinket_name);
	trinket_2_name = GetItemInfo(GetInventoryItemLink("player",14));
--	self:PTR("trinket_2",trinket_name);
end;

function ShamanWarning:PTR(name,data)
	if data ~= nil then
		ShamanWarning:Print(name..": "..data);
	else
		ShamanWarning:Print(name..": nil");
	end;
end;

function ShamanWarning:CheckTrinket(unitID)
--	if unitID == "player" or unitID == nil then
--		self:GetTrinket();
--		self:CheckArray(trinket_1_name,1);
--		self:CheckArray(trinket_2_name,2);
--	end;
end;

--function ShamanWarning:CheckArray(trinket,num)
--	local found = 0;
--	trinket_active = { false, false };
--	for k,v in pairs(trinket_list) do
--		if k == trinket or string.find(trinket, k) then
--			found = 1;
--		end;
--	end;
--	if found == 1 then
--		trinket_active[num] = true;
--	end;
--end;
